--- Z:\Fl_win32.cxx	2014-10-20 12:14:12.000000000 -0400
+++ Z:\Fl_win32_fixed.cxx	2014-12-06 18:27:27.685707200 -0500
@@ -1482,29 +1482,32 @@
 //   1   |  fix   |   yes
 //   2   |  size  |   yes
 
-int Fl_X::fake_X_wm(const Fl_Window* w,int &X,int &Y, int &bt,int &bx, int &by) {
+int Fl_X::fake_X_wm(const Fl_Window* w,int &X,int &Y, int &bt,int &bx, int &by, DWORD style, DWORD styleEx) {
   int W, H, xoff, yoff, dx, dy;
   int ret = bx = by = bt = 0;
 
   int fallback = 1;
   if (!w->parent()) {
-    HWND hwnd = fl_xid(w);
-    if (hwnd) {
+    if (fl_xid(w) || style) {
       // The block below calculates the window borders by requesting the
       // required decorated window rectangle for a desired client rectangle.
       // If any part of the function above fails, we will drop to a 
       // fallback to get the best guess which is always available.
-      HWND hwnd = fl_xid(w);
-      // request the style flags of this window, as WIN32 sees them
-      LONG style = GetWindowLong(hwnd, GWL_STYLE);
-      LONG exstyle = GetWindowLong(hwnd, GWL_EXSTYLE);
+      
+	 if (!style) {
+	     HWND hwnd = fl_xid(w);
+          // request the style flags of this window, as WIN32 sees them
+          style = GetWindowLong(hwnd, GWL_STYLE);
+          styleEx = GetWindowLong(hwnd, GWL_EXSTYLE);
+	 }
+
       RECT r;
       r.left = w->x();
       r.top = w->y();
       r.right = w->x()+w->w();
       r.bottom = w->y()+w->h();
       // get the decoration rectangle for the desired client rectangle
-      BOOL ok = AdjustWindowRectEx(&r, style, FALSE, exstyle);
+      BOOL ok = AdjustWindowRectEx(&r, style, FALSE, styleEx);
       if (ok) {
         X = r.left;
         Y = r.top;
@@ -1832,8 +1835,14 @@
       }
     }
     styleEx |= WS_EX_WINDOWEDGE | WS_EX_CONTROLPARENT;
-    int xwm = xp , ywm = yp , bt, bx, by;
-    switch (fake_X_wm(w, xwm, ywm, bt, bx, by)) {
+
+    int wintype = 0;
+    if (w->border() && !w->parent()) {
+      if (w->size_range_set && (w->maxw != w->minw || w->maxh != w->minh)) wintype = 2;
+	  else wintype = 1;
+    }
+
+    switch (wintype) {
       // No border (used for menus)
       case 0:
         style |= WS_POPUP;
@@ -1854,6 +1863,9 @@
           style |= WS_MINIMIZEBOX;
         break;
     }
+
+    int xwm = xp , ywm = yp , bt, bx, by;
+    fake_X_wm(w, xwm, ywm, bt, bx, by, style, styleEx);
     if (by+bt) {
       wp += 2*bx;
       hp += 2*by+bt;
